
public class M06Maze {
	//----------------------------萔
	//
	static final int DIRECT_X_PLUS=0;
	static final int DIRECT_X_MINUS=1;
	static final int DIRECT_Y_PLUS=2;
	static final int DIRECT_Y_MINUS=3;
	static final int DIRECT_Z_PLUS=4;
	static final int DIRECT_Z_MINUS=5;
	static final int DIRECT_LIMIT=6;
	//
	final int WAY_X=0;
	final int WAY_Y=1;
	final int WAY_Z=2;
	//̕ֈړۂ̊e̕ω
	final int way[/*direct*/][/*way*/]={{1,0,0},{-1,0,0},{0,1,0},{0,-1,0},{0,0,1},{0,0,-1}};
	//------------------------------ϐ
	//Hf[^
	int dist_x,dist_y,dist_z;
	boolean maze_data[][][];
	//݈ʒu
	int pos_x_s,pos_y_s,pos_z_s;
	int pos_x,pos_y,pos_z;
	//H쐬p
	int cont_limit;
	int route_limit;
	//-----------------------------------
	//RXgN^
	public M06Maze(int dist_x,int dist_y,int dist_z){
		//H쐬p
		cont_limit=6;
		route_limit=50;
		//H̑傫Zbg
		this.dist_x=dist_x;
		this.dist_y=dist_y;
		this.dist_z=dist_z;
		//݈ʒuilj
		pos_x_s=(int)(dist_x/2);
		pos_y_s=0;
		pos_z_s=(int)(dist_z/2);
		formatPos();
		//H
		formatMaze();
		//H쐬
		makeMaze();
	}
	public void formatPos(){
		//݈ʒuilj
		pos_x=pos_x_s;
		pos_y=pos_y_s;
		pos_z=pos_z_s;
	}
	//------------------------------
	//H
	private void formatMaze(){
		//
		maze_data=new boolean[dist_x][dist_y][dist_z];
		for(int x=0;x<dist_x;x++){
			for(int y=0;y<dist_y;y++){
				for(int z=0;z<dist_z;z++){
					maze_data[x][y][z]=false;	//Sĕ
				}
			}
		}
	}
	//----------------------------------
	//H쐬
	private void makeMaze(){
		//
		for(int i=0;i<10;i++){
			makeRoute();	//ʘH쐬
		}
	}
	//----------------------------------
	//ʘH쐬
	private void makeRoute(){
		//
		int ox,oy,oz;
		int px,py,pz;
		//Jnʒǔ
		if(maze_data[pos_x][pos_y][pos_z]){		//Qڈȍ~
			do{		//ʘHɂȂ܂ŁiA邽߁j
				px=rnd(0,dist_x);
				py=rnd(0,dist_y);
				pz=rnd(0,dist_z);
			}while(!maze_data[px][py][pz]);
		}else{									//P
			//݈ʒuiljɕ쐬
			for(int x=-1;x<=1;x++){
				for(int z=-1;z<=1;z++){
					maze_data[pos_x+x][pos_y][pos_z+z]=true;	//
				}
			}
			//Jnʒu
			px=pos_x;
			py=pos_y;
			pz=pos_z-1;	//݈ʒuiljőɌJɂ悤
		}
		//l
		int cont=0;
		int direct=DIRECT_X_PLUS;
		//ʘH΂
		for(int i=0;i<route_limit;i++){
			//K萔i񂾁ÁAQOsȂĐݒ
			if(cont==0 || checkRoute(px,py,pz,direct)){
				cont=rnd(3,cont_limit+1);
				direct=rnd(DIRECT_X_PLUS,DIRECT_LIMIT);
			}
			//Öʒui[
			ox=px;
			oy=py;
			oz=pz;
			//Vʒuֈړ
			px+=way[direct][WAY_X];
			py+=way[direct][WAY_Y];
			pz+=way[direct][WAY_Z];
			//͈͊Õ`FbN
			if(checkRange(px,py,pz)){
				//Öʒuɖ߂
				px=ox;
				py=oy;
				pz=oz;
				//Đݒ
				cont=rnd(3,cont_limit+1);
				do{		//͈͓ɂȂ܂
					direct=rnd(DIRECT_X_PLUS,DIRECT_LIMIT);
				}while( checkRange(px+way[direct][WAY_X],py+way[direct][WAY_Y],pz+way[direct][WAY_Z]) );
			}
			//ʘHɂ
			maze_data[px][py][pz]=true;
			if(cont>=0){
				cont--;
			}
		}
	}
	//-----------------------------
	//͈͊Õ`FbN
	private boolean checkRange(int px,int py,int pz){
		if(px<0 || px>=dist_x || py<0 || py>=dist_y || pz<0 || pz>=dist_z){
			return true;
		}
		return false;
	}
	//------------------------------
	//QO̒ʘH`FbNiʘH쐬j
	private boolean checkRoute(int px,int py,int pz,int direct){
		int qx=px+way[direct][WAY_X]*2;
		int qy=py+way[direct][WAY_Y]*2;
		int qz=pz+way[direct][WAY_Z]*2;
		//͈͊O
		if(checkRange(qx,qy,qz)){
			return true;
		}
		//ʘH
		if(maze_data[qx][qy][qz]){
			return true;
		}
		//
		return false;
	}
	//----------------------------------
	//PO̒ʘH`FbNiړj
	private boolean checkRoute(int direct){
		int qx=pos_x+way[direct][WAY_X];
		int qy=pos_y+way[direct][WAY_Y];
		int qz=pos_z+way[direct][WAY_Z];
		//͈͊O
		if(checkRange(qx,qy,qz)){
			return false;
		}
		//ǂ
		if(!maze_data[qx][qy][qz]){
			return false;
		}
		//
		return true;
	}
	//------------------------------
	//Hf[^̏o
	public boolean[] getMazeData(){
		boolean data[]=new boolean[dist_x*dist_y*dist_z];
		int num=0;
		for(int y=0;y<dist_y;y++){
			for(int z=0;z<dist_z;z++){
				for(int x=0;x<dist_x;x++){
					data[num]=maze_data[x][y][z];
					num+=1;
				}
			}
		}
		return data;
	}
	public boolean setMazeData(boolean[] data){
		if(data.length==dist_x*dist_y*dist_z){
			int num=0;
			for(int y=0;y<dist_y;y++){
				for(int z=0;z<dist_z;z++){
					for(int x=0;x<dist_x;x++){
						maze_data[x][y][z]=data[num];
						num+=1;
					}
				}
			}
			formatPos();
			return true;
		}else{
			return false;
		}
	}
	//---------------------------
	//
	private int rnd(int min,int max){
		return (int)((max-min)*Math.random()+min);
	}
	//------------------------
	//Hړ
	public void move(int direct){
		//͈͊Õ`FbN
		if(checkRoute(direct)){
			//
			pos_x+=way[direct][WAY_X];
			pos_y+=way[direct][WAY_Y];
			pos_z+=way[direct][WAY_Z];
		}
	}
}
